/*
 * ce4.c
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define MAX_SIZE  (80 + 1 + 1) /* + +'\0' */
#define WIDTH     80           /*  */
#define YES       1
#define NO        0
#define ISBLANK(c)      ((c) == ' ' || (c) == '\t')


int   carte(FILE *);
void  center(char [], int);
void  remove_pre_blank(char *);
void  remove_pos_blank(char *);
int   alldigit(char *);
void  usage(void);
void  cant(char *);

int   width = WIDTH;


main(int argc, char **argv)
{
    FILE  *fp;
    char  *s;
    int   r;

    /* ץβϤΥ */
    while (--argc > 0 && **++argv == '-') {
        for (s = *argv + 1; *s != '\0'; s++) {
            switch (*s) {
            case 'w':
                if (alldigit(s + 1) == NO)
                    usage(); /* no return */
                width = atoi(s + 1);
                while (*(++s + 1))
                    ;
                break;
            default:
                usage(); /* no return */
            }
        }
    }
    if (width <= 0 || WIDTH < width)
        usage(); /* no return */

    if (argc == 0) {
        if (carte(stdin) != 0)
            return (1);
    }
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv); /* no return */
            r = carte(fp);
            fclose(fp);
            if (r != 0)
                return (1);
            argv++;
        }
    }
    return (0);
}


int   carte(FILE *fp)
{
    char  buf[MAX_SIZE];

    while (fgets(buf, MAX_SIZE, fp) != NULL) {
        remove_pre_blank(buf);
        remove_pos_blank(buf);
        center(buf, width);
        if (fputs(buf, stdout) == EOF) {
            fprintf(stderr, "ce4: write error\n");
            return (-1);
        }
    }
    return (0);
}


void  center(char buf[], int w)
{
    int   n;
    int   off;

    n = strlen(buf) - 1;
    if (w < n)
        return;
    off = (w - n + 1) / 2;
    n += 2;     /* +2 for '\n'+'\0' */
    while (n--)
        buf[n + off] = buf[n];
    while (off--)
        buf[off] = ' ';
}


void  remove_pre_blank(char *buf)
{
    int   n;
    char  *p;
    char  *q;

    for (p = buf; ISBLANK(*p); p++)
        ;
    q = buf;
    n = strlen(p) + 1;
    while (n--)
        *q++ = *p++;
}


void  remove_pos_blank(char *buf)
{
    char  *q;

    if (*buf == '\0')
        return;
    q = buf + strlen(buf) - 1; /* 1\nʬ */
    while (q > buf && ISBLANK(*(q - 1)))
        --q;
    *q = '\n';
    *(q + 1) = '\0';
}

int   alldigit(char *s)
{
    if (*s == '\0')
        return (NO);
    for (; *s != '\0'; s++) {
        if (!isdigit(*s))
            return (NO);
    }
    return (YES);
}


void  usage(void)
{
    fprintf(stderr, "Usage: ce4 [-wNN] [file ...]\n");
    exit(1);
}


void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
