/*
 * edit.c - ƥȥǥ
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "line.h"

#define COM_LINE_MAX  256
#define R_NEXT        0
#define R_QUIT        1
#define R_CONT        (-1)


static int   edit(char *);
static char  *command(int *);
static void  usage(void);


main(int argc, char **argv)
{
    --argc;
    ++argv;
    if (argc == 0)
        usage();    /* no return */
    else {
        while (argc--) {
            if (edit(*argv++) != R_NEXT)
                break;
        }
    }
    return (0);
}


static int    edit(char *file)
{
    char  buf[MAX_SIZE];
    LINE  *cur;
    LINE  *tmp;
    int   rcode;
    char  *cp;
    int   a_no;

    rcode = R_CONT;
    cur = read_lines(init_lines(), file);

    while (rcode == R_CONT && (cp = command(&a_no)) != NULL) {
        if (a_no > 0)
            cur = get_line(a_no);
        switch (*cp) {
        case 'w':
            write_lines(get_line(1), get_line(ENDLINE), file);
            break;
        case 'q':
            rcode = R_QUIT;
            break;
        case 'n':
            rcode = R_NEXT;
            break;
        case 'a':
            while (fgets(buf, MAX_SIZE, stdin) != NULL) {
                if (buf[0] == '.' && buf[1] == '\n')
                    break;
                cur = add_line(cur, buf);
            }
            break;
        case 'i':
            tmp = cur;
            while (fgets(buf, MAX_SIZE, stdin) != NULL) {
                if (buf[0] == '.' && buf[1] == '\n')
                    break;
                tmp = ins_line(cur, buf);
            }
            cur = tmp;
            break;
        case 'd':
            cur = del_line(cur);
            break;
        case 'p':
            print_lines(cur, cur);
            break;
        case '-':
            if ((tmp = prev_line(cur)) != cur) {
                cur = tmp;
                print_lines(cur, cur);
            }
            break;
        case '\n':
            if ((tmp = next_line(cur)) != cur) {
                cur = tmp;
                print_lines(cur, cur);
            }
            break;
        }
    }
    delete_all_lines();
    return (rcode);
}


static char  *command(int *a)
{
    static char  cbuf[COM_LINE_MAX];
    char  *p;
    int   n;

    *a = -1;
    fprintf(stdout, ":");
    if (fgets(cbuf, COM_LINE_MAX, stdin) == NULL)
        return (NULL);
    p = cbuf;
    if (isdigit(*p)) {
        for (n = 0; isdigit(*p); p++)
            n = n * 10 + (*p - '0');
        *a = n;
    }
    return (p);
}


static void    usage(void)
{
    fprintf(stderr, "Usage: edit file [...]\n");
    exit(1);
}
