/*
 * find2.c
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_SIZE      (80 + 1 + 1) /* + +'\0' */
#define MAX_KEY_SIZE  (40 + 1 + 1) /* + +'\0' */
#define MAX_KEY_COUNT 256          /* κ */


void  find(FILE *, char **, int);
int   readkey(char **, FILE *);
void  freekey(int, char **);
void  usage(void);
void  cant(char *);

char *keyword[MAX_KEY_COUNT];
int   key_n;


main(int argc, char **argv)
{
    FILE  *fp;
    char  *s;

    key_n = -1;
    while (--argc > 0 && **++argv == '-') {
        for (s = *argv + 1; *s != '\0'; s++) {
            switch (*s) {
            case 'f':
                if (--argc > 0) {
                    if ((fp = fopen(*++argv, "r")) == NULL)
                        cant(*argv); /* no return */
                    else {
                        key_n = readkey(keyword, fp);
                        fclose(fp);
                    }
                }
                break;
            default:
                freekey(key_n, keyword);
                usage(); /* no return */
            }
        }
    }

    if (key_n == -1) {
        if (argc < 0)
            usage(); /* no return */
        --argc;
        keyword[0] = strdup(*argv++);
        key_n = 1;
    }

    if (argc == 0)
        find(stdin, keyword, key_n);
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv); /* no return */
            find(fp, keyword, key_n);
            fclose(fp);
            argv++;
        }
    }
    freekey(key_n, keyword);
    return (0);
}


void  find(FILE *fp, char *word[], int n)
{
    char  buf[MAX_SIZE];
    int   i;

    while (fgets(buf, MAX_SIZE, fp) != NULL) {
        for (i = 0; i < n; i++) {
            if (strstr(buf, word[i])) {
                fputs(buf, stdout);
                break;
            }
        }
    }
}


/* ѥե뤫鸡ɤ߹¸ */
int   readkey(char **key, FILE *fp)
{
    char  buf[MAX_KEY_SIZE];
    int   n;

    n = 0;
    while (fgets(buf, MAX_KEY_SIZE, fp) != NULL) {
        buf[strlen(buf) - 1] = '\0'; /* ԤĤ֤ */
        key[n++] = strdup(buf);
    }
    return (n);
}


/* ѤΥ꡼ */
void  freekey(int n, char **key)
{
    int   i;

    for (i = 0; i < n; i++)
        free(key[i]);
}


/* ޥɤɽƽλ */
void  usage(void)
{
    fprintf(stderr, "Usage: find2 keyword [file ...]\n");
    fprintf(stderr, "       find2 -f keyfile [file ...]\n");
    exit(1);
}


void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
