/*
 * line.c - ꥹȹ¤Ѵؿ
 */
#include <stdio.h>
#include <stdlib.h>
#include "line.h"

#if defined(_MSC_VER)
#include <string.h>
#else
char  *strdup(char *);
#endif
static void  message(char *msg);

static LINE  list = {&list, &list, NULL};


/* ꥹȹ¤ */
LINE  *init_lines(void)
{
    delete_all_lines();
    return (&list);
}


/* ιԤ */
LINE  *prev_line(LINE *c)
{
    if (c->prev == &list)
        message("at Top-of-file");
    else
        c = c->prev;
    return (c);
}


/* ιԤ */
LINE  *next_line(LINE *c)
{
    if (c->next == &list)
        message("at End-of-file");
    else
        c = c->next;
    return (c);
}


/* nԤΥǡؤΥݥ󥿡 */
LINE  *get_line(int n)
{
    LINE  *p;

    if (n == ENDLINE)
        return (list.prev);
    p = &list;
    while (n--) {
        if (p->next == &list)
            break;
        p = p->next;
    }
    return (p);
}


/* 1ʬΥǡ()ɲ */
LINE  *add_line(LINE *c, char *buf)
{
    LINE  *np;  /* for new object */

    if ((np = (LINE *)malloc(sizeof(LINE))) == NULL) {
        message("can't alloc memory");
        return (c);
    }
    if ((np->buf = strdup(buf)) == NULL) {
        message("can't alloc memory");
        free(np);
        return (c);
    }
    np->prev = c;
    np->next = c->next;
    c->next->prev = np;
    c->next = np;
    return (np);
}


/* 1ʬΥǡ() */
LINE  *ins_line(LINE *c, char *buf)
{
    LINE  *np;    /* for new object */

    if ((np = (LINE *)malloc(sizeof(LINE))) == NULL) {
        message("can't alloc memory");
        return (c);
    }
    if ((np->buf = strdup(buf)) == NULL) {
        message("can't alloc memory");
        free(np);
        return (c);
    }
    np->next = c;
    np->prev = c->prev;
    c->prev->next = np;
    c->prev = np;
    return (np);
}


/* 1ʬΥǡ */
LINE  *del_line(LINE *c)
{
    LINE  *p;

    p = c->next;
    c->next->prev = c->prev;
    c->prev->next = c->next;
    free(c->buf);
    free(c);
    return (p);
}


/* ٤ƤιԤ */
void  delete_all_lines(void)
{
    LINE  *p;

    for (p = list.next; p != &list; p = del_line(p))
        ;
}


/* ե뤫ɤ߹ */
LINE  *read_lines(LINE *c, char *file)
{
    char  buf[MAX_SIZE];
    FILE  *fp;

    if ((fp = fopen(file, "r")) == NULL)
        message("New file");
    else {
        while (fgets(buf, MAX_SIZE, fp) != NULL)
            c = add_line(c, buf);
        (void)fclose(fp);
    }
    return (c);
}


/* ե˽񤭽Ф */
void  write_lines(LINE *sp, LINE *ep, char *file)
{
    FILE  *fp;
    LINE  *p;

    if ((fp = fopen(file, "w")) == NULL) {
        message("write error");
        return;
    }
    for (p = sp; p != &list; p = p->next) {
        fputs(p->buf, fp);
        if (p == ep)
            break;
    }
    (void)fclose(fp);
}


/* ɸϤɽ */
void  print_lines(LINE *sp, LINE *ep)
{
    LINE  *p;

    for (p = sp; p != &list; p = p->next) {
        fputs(p->buf, stdout);
        if (p == ep)
            break;
    }
}


/* åν */
static void  message(char *msg)
{
    fprintf(stdout, "%s\n", msg);
}
