/*
 * page3.c - ƥȥե1̤ɽ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "line.h"

#define LINE_SIZE  (80 + 1 + 1) /* 80 + Ԥʬ + '\0'ʬ */
#define LINES_PAGE  23 /* 1̤ιԿ */
#define R_QUIT_ALL  0  /* ٤ƽλ */
#define R_LINE_NEXT 1  /* line */
#define R_LINE_PREV 2  /* line */
#define R_PAGE_NEXT 3  /* page */
#define R_PAGE_PREV 4  /* page */
#define R_FILE_NEXT 5  /* file */
#define R_FILE_PREV 6  /* file */


extern LINE    list;

static int   paging(FILE *fp, int n);
static void  show_page(int, int);
static int   key_wait(void);
#if HAVE_GETCH
static void  prompt(char *str);
static void  noprompt(char *str);
#endif
static void  usage(void);
static void  cant(char *);


main(int argc, char **argv)
{
    FILE  *fp;
    int   r;

    --argc;
    ++argv;
    if (argc == 0)
        usage();
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv);
            r = paging(fp, LINES_PAGE);
            (void)fclose(fp);
            if (r == R_QUIT_ALL)
                break;
            argv++;
        }
    }
    return (0);
}


/*
 * paging() - 1̤Ȥɽƻߤޤ꼡ΥϤԤ
 */
static int   paging(FILE *fp, int n)
{
    char  buf[LINE_SIZE];
    int   c;
    int   all;
    LINE  *cur;
    int   ln;

    cur = &list;
    all = 0;
    while (fgets(buf, LINE_SIZE, fp) != NULL) {
        if ((cur = add_line(cur, buf)) == NULL) {
            fprintf(stderr, "can't alloc memory\n");
            delete_all_lines();
            return (R_QUIT_ALL);
        }
        ++all;
    }

    ln = 1;
    show_page(ln, n);
    if (all <= n) {
        delete_all_lines();
        return (R_FILE_NEXT);
    }
    else {
        while ((c = key_wait()) != R_QUIT_ALL) {
            switch (c) {
            case R_FILE_NEXT:
                delete_all_lines();
                return (R_FILE_NEXT);
            case R_LINE_NEXT:
                ++ln;
                if (ln > all - n + 1)
                    ln = all - n + 1;
                show_page(ln, n);
                break;
            case R_PAGE_NEXT:
                ln += n;
                if (ln > all - n + 1)
                    ln = all - n + 1;
                show_page(ln, n);
                break;
            case R_PAGE_PREV:
                ln -= n;
                if (ln <= 0)
                    ln = 1;
                show_page(ln, n);
                break;
            }
        }
    }
    delete_all_lines();
    return (R_QUIT_ALL);
}


/*
 * show_page() - 1ʬɽ
 */
static void  show_page(int start, int n)
{
    LINE  *p;

    p = &list;
    while (start--)
        p = p->next;
    while (n--) {
        fputs(p->buf, stdout);
        if ((p = p->next) == &list)
            break;
    }
}


#if HAVE_GETCH
/*
 * key_wait() - ޤԤ(getch())
 */
static int   key_wait(void)
{
    prompt("--more--");
    for (;;) {
        switch (getch()) {
        case 'q':
            noprompt("--more--");
            return (R_QUIT_ALL);
        case 'n':
            noprompt("--more--");
            return (R_FILE_NEXT);
        case ' ':
            noprompt("--more--");
            return (R_PAGE_NEXT);
        case '\b': /* Back Space */
        case 'b':
            noprompt("--more--");
            return (R_PAGE_PREV);
        case '\r':
            noprompt("--more--");
            return (R_LINE_NEXT);
        }
    }
}
#else
/*
 * key_wait() - returnޤԤ
 */
static int   key_wait(void)
{
    char  comline[LINE_SIZE];

    fprintf(stderr, "--Hit Return Key--");
    (void)fgets(comline, LINE_SIZE, stdin);
    if (comline[0] == 'q')
        return (R_QUIT_ALL);
    else if (comline[0] == 'n')
        return (R_FILE_NEXT);
    else if (comline[0] == 'b')
        return (R_PAGE_PREV);
    else
        return (R_PAGE_NEXT);
}
#endif


#if HAVE_GETCH
static void  prompt(char *str)
{
    cprintf("%s", str);
}
#endif


#if HAVE_GETCH
static void  noprompt(char *str)
{
    int   n;
    int   i;

    n = strlen(str);
    for (i = 0; i < n; i++)
          putch('\b');
    for (i = 0; i < n; i++)
          putch(' ');
    for (i = 0; i < n; i++)
          putch('\b');
}
#endif


static void  usage(void)
{
    fprintf(stderr, "Usage: page3 file [...]\n");
    exit(1);
}


static void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
